/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package app;

import sassy.agent.*;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.HeadlessException;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashMap;

import javax.swing.JFrame;
import javax.swing.JPanel;

import sassy.LogicalProcess;

import java.awt.BorderLayout;
import java.io.Serializable;

import javax.swing.BorderFactory;
import javax.swing.JSlider;
import javax.swing.Timer;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;


/**
 *
 * @author Cole Sherer <koleslaw54@gmail.com>
 */
public class AgentBallGUI extends LogicalProcess implements Serializable {

	public static double enviX;
	public static double enviY;
	public static boolean endOfSimulation = false;
	public static HashMap<String, AgentBallMsg> ballMap =
			new HashMap<String, AgentBallMsg>();

	@Override
	public void appFinalizeLP()
	{
		endOfSimulation = true;
	}


	@Override
	public void appInitializeLP()
	{
		GUIFrame guiFrame = new GUIFrame();
	}


	@Override
	public void appRunLP(Object content, String sender)
	{
		AgentMessage msg = (AgentMessage)content;
		AgentBallMsg ball = (AgentBallMsg)msg.getContent();

		ballMap.put(sender, ball);
	}


	@Override
	public Serializable appSaveLPState()
	{
		AgentBallGUI eMonitor = new AgentBallGUI();
		return eMonitor;
	}


	@Override
	public void appSetConfigData(Serializable cdata)
	{
		String[] s = ((String)cdata).split(" ");
		enviX = Double.parseDouble(s[0]);
		enviY = Double.parseDouble(s[1]);
	}


	@Override
	public void appSetLPState(Serializable lp)
	{
	}
}

class GUIFrame extends JFrame implements ActionListener
{
	//private Container frameContainer;
	//private JPanel guiPanel = new JPanel();


	public GUIFrame() throws HeadlessException
	{
		super("Agent Ball Simulator");
		setSize((int) AgentBallGUI.enviX, (int) AgentBallGUI.enviY + 100);
		setResizable(false);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		getContentPane().add(new ApplicationPanel());
		pack();
		setVisible(true);

	}
	
	public void actionPerformed(ActionEvent arg0) {}
}


/*
 * NewFrame.java
 *
 * Created on September 23, 2007, 11:18 PM
 */
class ApplicationPanel extends JPanel
{
	BallPanel ballPanel;

	//private javax.swing.JLabel jLabel1;
	private javax.swing.JPanel buttonPanel;
	private javax.swing.JScrollPane jScrollPane1;
	private javax.swing.JSlider jSlider1;
	private javax.swing.JTextArea jTextArea1;
	private javax.swing.JButton startButton;
	private javax.swing.JButton stopButton;


	/** Creates new form NewFrame */
	public ApplicationPanel() {
		try {
			initComponents();
		}
		catch (Exception e) {}
	}


	private void initComponents() throws Exception
	{
		ballPanel = new BallPanel();
		ballPanel.run();
		jScrollPane1 = new javax.swing.JScrollPane();
		jTextArea1 = new javax.swing.JTextArea();
		buttonPanel = new javax.swing.JPanel();
		startButton = new javax.swing.JButton();
		stopButton = new javax.swing.JButton();


		jSlider1 = new javax.swing.JSlider(JSlider.HORIZONTAL, 1, 200, 200);
		jSlider1.setBorder(BorderFactory.createTitledBorder("Print Update Intervel"));
		jSlider1.setInverted(true);
		jSlider1.setMajorTickSpacing(50);
		jSlider1.setPaintTicks(true);
		jSlider1.addChangeListener(new ChangeListener()
		{
			public void stateChanged(ChangeEvent evt)
			{
				ballPanel.interval = jSlider1.getValue();
//        		ballPanel.run();
			}
		});

		jTextArea1.setColumns(20);
		jTextArea1.setRows(5);
		jScrollPane1.setViewportView(jTextArea1);

		startButton.setText("Start");
		startButton.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(java.awt.event.ActionEvent evt)
			{
				startButtonActionPerformed(evt);
			}
		});
		buttonPanel.add(startButton);

		stopButton.setText("Stop");
		stopButton.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(java.awt.event.ActionEvent evt)
			{
				stopButtonActionPerformed(evt);
			}
		});
		buttonPanel.add(stopButton);

		jSlider1.addChangeListener(new javax.swing.event.ChangeListener()
		{
			public void stateChanged(javax.swing.event.ChangeEvent evt)
			{
				jSlider1StateChanged(evt);
			}
		});
		buttonPanel.add(jSlider1);
		this.setLayout(new BorderLayout());
		add(buttonPanel, java.awt.BorderLayout.NORTH);
		add(ballPanel, java.awt.BorderLayout.SOUTH);


	}


	private void jSlider1StateChanged(javax.swing.event.ChangeEvent evt)
	{
		ballPanel.mTimer.setDelay(jSlider1.getValue());
	}


	private void stopButtonActionPerformed(java.awt.event.ActionEvent evt)
	{
		ballPanel.setAnimation(false);
	}


	private void startButtonActionPerformed(java.awt.event.ActionEvent evt)
	{
		ballPanel.setAnimation(true);
	}


	/** Exit the Application */
	private void exitForm(java.awt.event.WindowEvent evt)
	{
		System.exit(0);
	}
}

/**1. Read config files
 * 1. Creates balls
 * 2  MOVE the balls
 * 3  Paint the balls
 * @author hth
 */
class BallPanel extends JPanel
{
	public int interval;

	public Timer mTimer;


	/** Creates a new instance of AnimationControl */
	public BallPanel() throws Exception
	{

		//need change
		setPreferredSize(new Dimension((int) AgentBallGUI.enviX, (int) AgentBallGUI.enviY));
		setBorder(BorderFactory.createLineBorder(Color.BLACK));
	}


	public void run()
	{
		repaint();
		mTimer = new Timer(interval, new TimerAction());
		mTimer.start();
	}

	//set start and stop of the animation

	public void setAnimation(boolean turnOnOff)
	{
		if (turnOnOff)
			mTimer.start();  // start animation by starting the timer.
		else
			mTimer.stop();   // stop timer
	}

	class TimerAction implements ActionListener
	{
		public void actionPerformed(ActionEvent e)
		{
			if (!AgentBallGUI.endOfSimulation)
			{
				repaint();
			}
			else
				mTimer.stop();
		}
	}


	@Override
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);  // Paint background, border

		for (AgentBallMsg ball : AgentBallGUI.ballMap.values())
		{
			
			// g.setColor(Color.BLUE);
			// Body2D body = (Body2D)ball.getBody();
			double r = ball.getRadius();

			g.fillOval((int)(ball.getX() - r), (int)(ball.getY() - r),
						2 * (int)r, 2 * (int)r);

		}
	}
}