package app;

import java.io.Serializable;
import sassy.*;
import java.util.*;
import sassy.monitoring_steering.NameValuePair;

/**This class represents a hole in the tileworld. 
  *
  *@author Yin Xiong
  *@version 1.0 (05/2007)
  */
  

public class Hole extends LogicalProcess{

	/**the flag for displaying debugging info*/
	private static final boolean  STRACE = false;

	/**the alias of this object; for debugging only*/
	String alias;

	/**Constructs a new TileWorker instance.*/
	public Hole()
	{
  	 	super();
		alias=getPID() + "-" + getLID();		
	}


	/**Sets application-specific configuration data.
 	* @param cdata String representing configuration data
 	*/
	@Override
	public void appSetConfigData(Serializable cdata)
	{
	}//end appSetConfigData

	/**Initiates the LP and generates the initial message. 
  	*/
	@Override
	public void appInitializeLP()
	{
	}//end appInitializeLP


	/**Handles events.
 	 *@param content an Object representing the content of the message to be sent
  	 *@param sender String the application-assigned name of the sender of this message
  	 */
	@Override
	public void appRunLP(Object content, String sender)
	{
	}//end appRunLP

	/**Terminates LP and displays simulation statistics. It is optionally called at the end of the
  	*simulation. It is the counterpart of "FProc" in GTW.
  	*/
	@Override
	public void appFinalizeLP()
	{
	//System.out.println(alias + " is finalizing...\n");
	}

	void tSleep(int tim)
	{
   		try{
     			Thread t=Thread.currentThread();
     			Thread.sleep(tim);
   		}
   		catch(Exception e){
     			e.printStackTrace();
  		}
	}//end tSleep


	/**Implements abstract method to save LP state*/	
	@Override
	public Serializable appSaveLPState()
	{
   		return null;
	}

	/**Implements abstract method to set the state of this LP to the state of a specified Phold*/
	public void appSetLPState(Serializable lp)
	{
	}//end setState


	/** Returns a Vector of NameValuePair describing all application-specific steerable
         * parameters of this LP, each NameValuePair is in the form "paramName, paramType".
         * @since 1.5
         */
	@Override
        public Vector<NameValuePair> appGetSteerable()
        {
                Vector<NameValuePair> nvVector=new Vector<NameValuePair>();
                NameValuePair nv;
                nv=new NameValuePair("count", "int");
                nvVector.add(nv);
                return nvVector;
        }//end appGetSteerable


        /** Returns a Vector of NameValuePair describing all application-specific monitorable
         * parameters of this LP, each NameValuePair is in the form "paramName, paramType".
         * @since 1.5
         */
	@Override
        public Vector<NameValuePair> appGetMonitorable()
        {
                Vector<NameValuePair> nvVector=new Vector<NameValuePair>();
                NameValuePair nv;
                nv=new NameValuePair("count", "int");
                nvVector.add(nv);
                return nvVector;
        }//end appGetMonitorable


}//end Hole
