package app;

import java.io.Serializable;
import sassy.*;
import java.util.*;
import sassy.monitoring_steering.NameValuePair;

/**This class represents a tile worker who tries to use tiles to cover holes. 
  *
  *@author Yin Xiong
  *@version 1.0 (05/2007)
  */
  

public class TileWorker extends LogicalProcess{


	/**the alias of this object; for debugging only*/
	String alias;

	/** a queue of LPs within this tile worker's sense area*/
	PriorityQueue<LogicalProcess> neighbors=new PriorityQueue<LogicalProcess>();

	/**Constructs a new TileWorker instance.*/
	public TileWorker()
	{
  	 	super();
		alias=getPID() + "-" + getLID();		
	}


	/**Sets application-specific configuration data.
 	* @param cdata String representing configuration data
 	*/
	public void appSetConfigData(Serializable cdata)
	{
	}//end appSetConfigData

	/**Initiates the LP and generates the initial message. 
  	*/
	public void appInitializeLP()
	{
		alias=getPID() + " " + getLID();
		System.out.println(alias + " initializing...");

		//get environmental information and sends itself a message to propel forwar
		display(neighbors);
		System.out.println(alias + " app id: " + getAPPid());
		sendSimMessage("initialize", 0, getAPPid());
	}//end appInitializeLP


	/**Displays the contents of the queue; for debugging only*/
	void display(PriorityQueue<LogicalProcess> lpq)
	{
//		System.out.println("\nsensed " + lpq.size() + " objects");
//		for(int i=0;i<lpq.size();i++)
//		{
//			LogicalProcess lp=(LogicalProcess)lpq.poll();
//			System.out.println(lp.getPID()+ "-" + lp.getLID() + 
//					lp.getArea().toString());
//		}
	}//end display


	/**Handles events.
 	 *@param content an Object representing the content of the message to be sent
  	 *@param sender String the application-assigned name of the sender of this message
  	 */
	@Override
	public void appRunLP(Object content, String sender)
	{
//		//if there's no hole on the way, this tileworker move a step along the diagonal
//		display(neighbors);
//		if(neighbors==null)
//		{
//			System.out.println("Road clear, move one step...");
//			move(10,10,0);
//			act("move");
//		}//end if		
//		sendSimMessage("run", 0, getAPPid());

	}//end appRunLP

	/**Moves to a new location.
	  *@param xInc double the increment in x dimension.
	  *@param yInc double the increment in y dimension.
	  *@param zInc double the incremetn in z dimension.
          */
	void move(double xInc, double yInc, double zInc)
	{
//		getArea().getCenterPoint().move(xInc, yInc, zInc);
	}//end move
	
	/**Terminates LP and displays simulation statistics. It is optionally called at the end of the
  	*simulation. It is the counterpart of "FProc" in GTW.
  	*/
	@Override
	public void appFinalizeLP()
	{
	//System.out.println(alias + " is finalizing...\n");
	}

	void tSleep(int tim)
	{
   		try{
     			Thread t=Thread.currentThread();
     			Thread.sleep(tim);
   		}
   		catch(Exception e){
     			e.printStackTrace();
  		}
	}//end tSleep


	/**Implements abstract method to save LP state*/	
	@Override
	public Serializable appSaveLPState()
	{
//		TileWorker t=new TileWorker();
//		t.setArea(getArea());
//		
//		return (LogicalProcess)t;
		return null;
	}

	/**Implements abstract method to set the state of this LP to the state of a specified Phold*/
	@Override
	public void appSetLPState(Serializable lp)
	{
	}//end setState


	/** Returns a Vector of NameValuePair describing all application-specific steerable
         * parameters of this LP, each NameValuePair is in the form "paramName, paramType".
         * @since 1.5
         */
	@Override
        public Vector<NameValuePair> appGetSteerable()
        {
                Vector<NameValuePair> nvVector=new Vector<NameValuePair>();
                NameValuePair nv;
                nv=new NameValuePair("count", "int");
                nvVector.add(nv);
                return nvVector;
        }//end appGetSteerable


        /** Returns a Vector of NameValuePair describing all application-specific monitorable
         * parameters of this LP, each NameValuePair is in the form "paramName, paramType".
         * @since 1.5
         */
	@Override
        public Vector<NameValuePair> appGetMonitorable()
        {
                Vector<NameValuePair> nvVector=new Vector<NameValuePair>();
                NameValuePair nv;
                nv=new NameValuePair("count", "int");
                nvVector.add(nv);
                return nvVector;
        }//end appGetMonitorable


}//end TileWorker
