package app;

import java.util.*;
import sassy.*;
//import sassy.agentsim.BoundedArea;
//import sassy.agentsim.CenterPoint;

/**This class provides a default creator to the simulation. The format of the configuration file is:
 * appID appName className appConfigData
 * @version 1.0 (05/2007)
 * @author Yin xiong
 */
public class TileworldCreator implements Creator
{
	/**bounded area for the tileworld*/
	//BoundedArea twArea = null;
	
	/**the class name for breaking simultaneous events tie*/
	String simulEventComparator = null;


	/**Distributes the LP among the available PEs
	 *@param numPEs int the number of PEs in this simulation
	 *@param numLPs int the number of LPs in this simulation
	 */
	@Override
	public List<PEInfo> appSetPEtable(int numPEs, List<LPConfigInfo> lpConfigInfoVector)
	{
		List<PEInfo> peTable = new ArrayList<PEInfo>();
//		//assign each LP to a PE according to their location
//		for(int i=0;i<lpConfigInfoVector.size();i++)
//		{
//			LPConfigInfo lpc=(LPConfigInfo)lpConfigInfoVector.get(i);
//			CenterPoint ct=lpc.getArea().getCenterPoint();
//			for(int j=0;j<peTable.size();j++)
//			{
//				PEInfo peinfo=(PEInfo)peTable.get(j);
//				BoundedArea ba=peinfo.getArea();
//				//System.out.println("ct, ba: " + ct.toString() + ":" +ba.toString());
//				if(ba.contains(ct))
//				{
//					peinfo.lpcVector.add(lpc);
//					System.out.println("ba contains ct");
//				}
//			}//end j
//		}//end for i
		return peTable;
	}//end appAllocateLPs

	/**Processes LP configuration information.
	 *@param fileName String the name of the configuration file
	 *@return a vector of LPConfigInfo object, each being the configuration information for an LP
	 */
	@Override
	public List<LPConfigInfo> appCreateLPs(String fileName)
	{
		List<LPConfigInfo> lpConfigInfoVector = new ArrayList<LPConfigInfo>();
		//Read configuration file to decide how many instance for each class need to be created
				/*try
		{
		String newLine = null;
		BufferedReader bf = new BufferedReader(new FileReader(fileName));
		int numLPs=0;
		//Each line is of the format: "<line type>:type-specific info"
		//LP's are specified as "LP:<id> <name> <class name> <application data>"
		while ((newLine = bf.readLine()) != null)
		{
		//If the first character is a '#', this is a comment. Also, ignore blank lines
		if (newLine.trim().length() == 0 || newLine.charAt(0) == '#')
		continue;
		//Extract the type of line
		int pos = newLine.indexOf(':');
		if (pos == -1)
		{
		System.err.println("Error1: Malformated configration file.");
		System.exit(1);
		}
		String lineType = newLine.substring(0, pos).trim();
		newLine = newLine.substring(pos + 1).trim();
		//Now, process the line depending on what type it is
		if (lineType.equalsIgnoreCase("agent")|| lineType.equalsIgnoreCase("object"))
		{
		//Only split on the first 3 fields because the application data can have
		String[] tokens = newLine.split("\t");
		if (tokens.length < 3)
		{
		System.err.println("Error: Malformated configration file.");
		System.exit(1);
		}
		//System.out.println("tokens: " );
		//for(int i=0;i<tokens.length;i++)
		//	System.out.println("token " + i + " " + tokens[i]);
		String id = tokens[0].trim();
		String name = tokens[1].trim();
		String className = tokens[2].trim();
		String dat = tokens[3].trim();
		LPConfigInfo lpcInfo = new LPConfigInfo(numLPs, id, name, className, dat);
		System.out.println("dat: " + dat);
		BoundedArea ba=parseAreaInfo(dat);
		System.out.println("\nLP area: " + ba.toString());
		lpcInfo.setArea(ba);
		lpConfigInfoVector.add(lpcInfo);
		numLPs++;
		}
		else if(lineType.equalsIgnoreCase("tileworld") || lineType.equalsIgnoreCase("PE"))
		{
		BoundedArea ba=parseAreaInfo(newLine);
		//System.out.println("\nTW or PE area: " + ba.toString());
		if(lineType.equalsIgnoreCase("tileworld"))
		twArea=ba;
		//create a PEInfo object with only area information
		else
		{
		PEInfo peinfo=new PEInfo();
		peinfo.setArea(ba);
		peTable.add(peinfo);
		}
		}
		else if (lineType.equalsIgnoreCase("SimultenousMessageComparator"))
		{
		simulEventComparator = newLine;
		}
		} //end while
		bf.close();
		}
		catch (IOException e)
		{
		System.err.println("Error: Could not read configuration file:\n\t" + e.getMessage());
		}
		 */
		return lpConfigInfoVector;
	}

	/** Parses the area information.*/
	/*
	BoundedArea parseAreaInfo(String s)
	{
		
		//System.out.println("parse: " + s);
		String[] tokens = s.split(",");
		double x = Double.parseDouble(tokens[0]);
		double y = Double.parseDouble(tokens[1]);
		double z = Double.parseDouble(tokens[2]);
		double xSide = Double.parseDouble(tokens[3]);
		double ySide = Double.parseDouble(tokens[4]);
		double zSide = Double.parseDouble(tokens[5]);
		CenterPoint ct = new CenterPoint(x, y, z);
		BoundedArea ba = new BoundedArea(ct, xSide, ySide, zSide);
		return ba;
		
	}//end parseAreaInfo
*/
	public String getTieBreakerClass()
	{
		return null;
	}
}//end class TileworldCreator

