package app.antsim;

/**
 * Holds all constant parameters of the simulation.
 * @author George Vulov (georgevulov@hotmail.com)
 */
public class SimParams
{
	/** The with of the field. */
	public static final int MAX_X = 600;
	
	/** The height of the field. */
	public static final int MAX_Y = 600;
	
	/** Location of the food source. */
	public static final int FOOD_X = 500;
	
	/** Location of the food source. */
	public static final int FOOD_Y = 100;
	
	/** Location of the nest. */
	public static final int NEST_X = 100;
	
	/** Location of the nest. */
	public static final int NEST_Y = 500;
	
	/** How many ants to instantiate. */
	public static final int ANT_COUNT = 10;
	
	public static final int ANT_SPEED = 2;
	
	/** The width of an ant body. */
	public static final int ANT_SIGHT_RADIUS = 60;
	
	/** Pheromone agents are square agents responsible for managing pheromone levels. */
	public static final int PHEROMONE_AGENT_WIDTH = 40;
	
	/** How quickly pheromones diffuse. */
	public static final double DIFFUSION_RATE = 0.01;
	
	/** How quickly (as a percentage) of current pheromone the pheromones evaporate. */
	public static final double EVAPORATION_RATE = 0.004;
	
	/** The maximum pheromone levels, at the nest and at a food source. */
	public static final double MAX_PHEROMONE = 1000;
	
	/** How much lower the desired pheromone at a certain cell is than the maximum of its neighbors. */
	public static final double PHEROMONE_DESIRABILITY_DECREASE = 50;
	
	/** How close do we have to be to the nest (or to food) for it to count. */
	public static final double ANT_DESTINATION_THRESHOLD = 5;
	
	/** 
	 * The pheromone levels are raised to this power to make it more likely for ants to go to high
	 * pheromone locations. E.g. if one cell has pheromone level of 6 and another cell has pheromone level of 4,
	 * the probability of going to the first cell is 6^N / (6^N + 4^N)
	 */
		public static final double PHEROMONE_GREEDINESS = 3;
}
