package im;

import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.HeadlessException;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.Vector;

import javax.swing.JFrame;
import javax.swing.JPanel;

import sassy.LogicalProcess;

import java.awt.BorderLayout;
import java.io.Serializable;

import javax.swing.BorderFactory;
import javax.swing.JSlider;
import javax.swing.Timer;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 * In charge of monitoring all balls' location and print them.
 * The monitor lp subscribe all the position update from all IMLPs 
 * but never schedule any event.
 * 
 * This LP is optional, it can be excluded by changing the setting in config_script file.
 */
public class EnviromentMonitor extends LogicalProcess implements Serializable
{
	public static double radius;

	public static double enviX;

	public static double enviY;

	public static int numGrid;

	public static boolean endOfSimulation = false;

	public static ArrayList<MsgBall> ballList = new ArrayList<MsgBall>();


	@Override
	public void appFinalizeLP()
	{
		endOfSimulation = true;
	}


	@Override
	public void appInitializeLP()
	{
		//GUIFrame guiFrame = new GUIFrame();
	}


	@Override
	public void appRunLP(Object content, String sender)
	{

		AgentMsg messContent = (AgentMsg) content;
//		Ball ball = messContent.getBall();
		MsgBall ball = messContent.getMsgBall();

		//System.out.println("[Monitor]pulish message from "+ball.getAPPid());
		if (ballList.isEmpty())
		{
			ballList.add(ball);
		}
		else
		{
			boolean isMonitored = false;
			for (int index = 0; index < ballList.size(); index++)
			{
				if (ball.getAPPid().equals(ballList.get(index).getAPPid()))
				{
					ballList.set(index, ball);
					isMonitored = true;
					break;
				}
			}
			if (!isMonitored)
			{
				ballList.add(ball);
			}
		}
	}


	@Override
	public Serializable appSaveLPState()
	{
		EnviromentMonitor eMonitor = new EnviromentMonitor();
		return eMonitor;
	}


	@Override
	public void appSetConfigData(Serializable cdata)
	{
		String[] s = ((String)cdata).split(" ");

		radius = Double.parseDouble(s[0]);
		enviX = Double.parseDouble(s[1]);
		enviY = Double.parseDouble(s[2]);
		numGrid = Integer.parseInt(s[3]);
	}


	@Override
	public void appSetLPState(Serializable lp)
	{
	}
}

class GUIFrame extends JFrame implements ActionListener
{
	private Container frameContainer;

	private JPanel guiPanel = new JPanel();


	public GUIFrame() throws HeadlessException
	{
		super("Bouncing Ball Simulator");
		setSize((int) EnviromentMonitor.enviX, (int) EnviromentMonitor.enviY + 100);
		setResizable(false);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		getContentPane().add(new ApplicationPanel());
		pack();
		setVisible(true);

	}


	public void actionPerformed(ActionEvent arg0)
	{
	}
}


/*
 * NewFrame.java
 *
 * Created on September 23, 2007, 11:18 PM
 */
class ApplicationPanel extends JPanel
{
	BallPanel ballPanel;

	private javax.swing.JLabel jLabel1;

	private javax.swing.JPanel buttonPanel;

	private javax.swing.JScrollPane jScrollPane1;

	private javax.swing.JSlider jSlider1;

	private javax.swing.JTextArea jTextArea1;

	private javax.swing.JButton startButton;

	private javax.swing.JButton stopButton;


	/** Creates new form NewFrame */
	public ApplicationPanel()
	{
		try
		{
			initComponents();
//    		this.setVisible(true);
		}
		catch (Exception e)
		{
			//System.out.println("Error in ApplicationPanel "+e);
		}
	}


	private void initComponents() throws Exception
	{
		ballPanel = new BallPanel();
		ballPanel.run();
//    	ballPanel.setVisible(true);
		jScrollPane1 = new javax.swing.JScrollPane();
		jTextArea1 = new javax.swing.JTextArea();
		buttonPanel = new javax.swing.JPanel();
		startButton = new javax.swing.JButton();
		stopButton = new javax.swing.JButton();


		jSlider1 = new javax.swing.JSlider(JSlider.HORIZONTAL, 1, 200, 50);
		jSlider1.setBorder(BorderFactory.createTitledBorder("Print Update Intervel"));
		jSlider1.setInverted(true);
		jSlider1.setMajorTickSpacing(50);
		jSlider1.setPaintTicks(true);
		jSlider1.addChangeListener(new ChangeListener()
		{
			public void stateChanged(ChangeEvent evt)
			{
				ballPanel.interval = jSlider1.getValue();
//        		ballPanel.run();
			}
		});

		jTextArea1.setColumns(20);
		jTextArea1.setRows(5);
		jScrollPane1.setViewportView(jTextArea1);

		startButton.setText("Start");
		startButton.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(java.awt.event.ActionEvent evt)
			{
				startButtonActionPerformed(evt);
			}
		});
		buttonPanel.add(startButton);

		stopButton.setText("Stop");
		stopButton.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(java.awt.event.ActionEvent evt)
			{
				stopButtonActionPerformed(evt);
			}
		});
		buttonPanel.add(stopButton);

		jSlider1.addChangeListener(new javax.swing.event.ChangeListener()
		{
			public void stateChanged(javax.swing.event.ChangeEvent evt)
			{
				jSlider1StateChanged(evt);
			}
		});
		buttonPanel.add(jSlider1);
		this.setLayout(new BorderLayout());
		add(buttonPanel, java.awt.BorderLayout.NORTH);
		add(ballPanel, java.awt.BorderLayout.SOUTH);


	}


	private void jSlider1StateChanged(javax.swing.event.ChangeEvent evt)
	{
		ballPanel.mTimer.setDelay(jSlider1.getValue());
	}


	private void stopButtonActionPerformed(java.awt.event.ActionEvent evt)
	{
		ballPanel.setAnimation(false);
	}


	private void startButtonActionPerformed(java.awt.event.ActionEvent evt)
	{
		ballPanel.setAnimation(true);
	}


	/** Exit the Application */
	private void exitForm(java.awt.event.WindowEvent evt)
	{
		System.exit(0);
	}
}

/**1. Read config files
 * 1. Creates balls
 * 2  MOVE the balls
 * 3  Paint the balls
 * @author hth
 */
class BallPanel extends JPanel
{
	public int interval;

	public Timer mTimer;

	double lineUnitSpaceX;

	double lineUnitSpaceY;


	/** Creates a new instance of AnimationControl */
	public BallPanel() throws Exception
	{

		//need change
		setPreferredSize(new Dimension((int) EnviromentMonitor.enviX, (int) EnviromentMonitor.enviY));
		setBorder(BorderFactory.createLineBorder(Color.BLACK));
	}


	public void run()
	{
		lineUnitSpaceX = EnviromentMonitor.enviX / EnviromentMonitor.numGrid;
		lineUnitSpaceY = EnviromentMonitor.enviY / EnviromentMonitor.numGrid;
		repaint();
		mTimer = new Timer(interval, new TimerAction());
		mTimer.start();
	}

	//set start and stop of the animation

	public void setAnimation(boolean turnOnOff)
	{
		if (turnOnOff)
			mTimer.start();  // start animation by starting the timer.
		else
			mTimer.stop();   // stop timer
	}

	class TimerAction implements ActionListener
	{
		public void actionPerformed(ActionEvent e)
		{
			if (!EnviromentMonitor.endOfSimulation)
			{
				repaint();
			}
			else
				mTimer.stop();
		}
	}


	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);  // Paint background, border

		//paint horizontal line
		int locationY = 0;
		while (locationY < EnviromentMonitor.enviY)
		{
			locationY += lineUnitSpaceY;
			g.drawLine(0, (int) locationY, (int) EnviromentMonitor.enviX, (int) locationY);
		}

		//paint vertical line
		int locationX = 0;
		while (locationX < EnviromentMonitor.enviX)
		{
			locationX += lineUnitSpaceX;
			g.drawLine((int) locationX, 0, (int) locationX, (int) EnviromentMonitor.enviY);
		}

//    	Graphics2D g2 = (Graphics2D)g;
//    	g2.setColor(Color.red);
		int numNeighbor;
		Color ballColor;
		int colorDense;
		for (int index = 0; index < EnviromentMonitor.ballList.size(); index++)
		{
//        	//System.out.println("^^^^^^^X: "+balls.get(index).location.getX()+"Y: "+balls.get(index).location.getY());
			numNeighbor = EnviromentMonitor.ballList.get(index).getNumNeighbor();
			colorDense = 255 - 100 * numNeighbor;
			if (colorDense < 0)
				colorDense = 0;
			ballColor = new Color(colorDense, 255, 255);
			g.setColor(ballColor);
			g.fillOval((int) EnviromentMonitor.ballList.get(index).getCurrPosition().x - (int) EnviromentMonitor.radius, (int) EnviromentMonitor.ballList.get(index).getCurrPosition().y - (int) EnviromentMonitor.radius, 2 * (int) EnviromentMonitor.radius, 2 * (int) EnviromentMonitor.radius);

			//number of neighbors
			g.setColor(Color.RED);
			g.drawString(((Integer) numNeighbor).toString(), (int) EnviromentMonitor.ballList.get(index).getCurrPosition().x, (int) EnviromentMonitor.ballList.get(index).getCurrPosition().y);

			//ball ID
			g.setColor(Color.BLACK);
			g.drawString((EnviromentMonitor.ballList.get(index)).getAPPid(), (int) EnviromentMonitor.ballList.get(index).getCurrPosition().x - (int) EnviromentMonitor.radius, (int) EnviromentMonitor.ballList.get(index).getCurrPosition().y - (int) EnviromentMonitor.radius);

			//PE ID
//        	g.setColor(Color.BLACK);
//        	g.drawString(((Integer)EnviromentMonitor.ballList.get(index).getPID()).toString(), (int)EnviromentMonitor.ballList.get(index).currPosition.x+(int)EnviromentMonitor.radius, (int)EnviromentMonitor.ballList.get(index).currPosition.y+(int)EnviromentMonitor.radius);
		}
	}
}
