package sassy.agent;

/**
 * Used to "sense" other agents and objects located in the environment.
 *
 * @author Cole Sherer <koleslaw54@gmail.com>
 */
public abstract class Sensor {

	/**
	 * Determines whether or not the Sensor can sense the given Body.  This
	 * method is automatically called during the "sense" phase of an Agent's
	 * sense-think-act cycle.
	 *
	 * @param body the Body to test against
	 * @return true if the Body can be sensed, false otherwise
	 */
	public abstract boolean canSense(Body body);
}
