package sassy.monitoring_steering;

import java.io.*;
import java.util.*;


/** This class represents a response to a monitoring command.
 *
 * @version 2.0
 * @author Yin Xiong
 * @author Glenn Matthews
 */
public class ReportNode implements Serializable
{

	/** The vector of values that was obtained by monitoring. */
	Vector<NameValuePair> resultVector;

	/** The simulation time at which this information was obtained. */
	int simTime;

	/** the ID of the client who requested this monitoring report*/
	String clientID;

	/** The id of the monitoring command*/
	String msgID;

	/** Basic constructor. */
	public ReportNode(String cid, String mid, int time, Vector<NameValuePair> val)
	{
		clientID = cid;
		msgID = mid;
		simTime = time;
		resultVector = val;
	} //constructor

	/** Converts this structure to a String of the format: varName, varValue
		*/
	public String stringValue()
	{
		StringBuffer s = new StringBuffer("clientID: " + clientID +
					"\tmsgID: " + msgID + "\tsimTime: " + simTime + "\t");

		for (int i = 0;i < resultVector.size();i++)
		{
			NameValuePair nv = resultVector.get(i);
			s.append(nv.getVarName() + ": " + nv.getVarValue() + "\t");
		} //end for

		return s.toString();
	} // stringValue()

} //ReportNode
