package sassy.monitoring_steering;

//SocketClient.java
// usage : java SocketClient <server> <port>
// default port is 1500

import java.util.*;
import java.net.*;
import java.io.*;

public class SocketClient {

    public static void main(String[] args) {
	boolean MTRACE=true;
	int port = 1500;
	String server = "localhost";
	String fileName="steer.txt";
	Socket socket = null;
	String lineToBeSent;
	BufferedReader input=null;
	BufferedReader reportReader=null;
	PrintWriter output=null;
	int ERROR = 1;
	boolean endOfMS=false;
	String reportReceived=null;

	// read arguments 
	if(args.length < 3) {
		System.out.println("Please enter port, server name and file name!");
		System.exit(0);
	}

	try { 
		port=Integer.parseInt(args[0]); 
		server = args[1];
		fileName=args[2];
	    }
	    catch (Exception e) {
	    }
	
	// connect to server
	try {
	    socket = new Socket(server, port);
	    System.out.println("Connected with server " +
				   socket.getInetAddress() +
				   ":" + socket.getPort());
		input = new BufferedReader(new FileReader(fileName)); 
		output = new PrintWriter(socket.getOutputStream(),true);
		reportReader = new BufferedReader(new InputStreamReader(socket.getInputStream()));
		if(MTRACE)
			System.out.println("reportReader: " + reportReader);
	
	}
	catch (UnknownHostException e) {
	    System.out.println(e);
	    System.exit(ERROR);
	}
	catch (IOException e) {
	    System.out.println(e);
	    System.exit(ERROR);
	}


	while(!endOfMS){
	 try {
			    
	    	// get user input and transmit it to server
    		lineToBeSent = input.readLine();
	    	while(lineToBeSent!=null){
			output.println(lineToBeSent);
			if(lineToBeSent.equalsIgnoreCase("EXIT")) {
				endOfMS = true;
			}
			System.out.println("send line: " + lineToBeSent);
		
			//sleep sometime before sending another command
			StringTokenizer st=new StringTokenizer(lineToBeSent,"\t");
			if(!st.nextToken().equalsIgnoreCase("*")){
               			Thread t=Thread.currentThread();
               			t.sleep(2000);
			}//end if
	
	    		lineToBeSent = input.readLine();
		}//end while line is not null

		
		System.out.println("Report received:");
		while((reportReceived=reportReader.readLine())!=null){
			System.out.println(reportReceived);
		}//end while
		
	}
	catch (Exception e) {
	    System.out.println(e);
	}
	}//end while not endOfSim

	try {
		input.close();
		output.close();
		System.out.println("input/output closed.");

	    socket.close();
	}
	catch (IOException e) {
	    System.out.println(e);
	}
 }//end main   
}//end class

